import type { Hash } from "@siteimprove/alfa-hash";
import { type Parser as CSSParser } from "../../../../syntax/index.js";
import { Length } from "../../../numeric/index.js";
import type { Resolvable } from "../../../resolvable.js";
import { Value } from "../../../value.js";
/**
 * {@link https://drafts.csswg.org/css-images/#valdef-ending-shape-circle}
 *
 * @internal
 */
export declare class Circle<R extends Length = Length> extends Value<"circle", Value.HasCalculation<[R]>> implements Resolvable<Circle.Canonical, Circle.Resolver> {
    static of<R extends Length>(radius: R): Circle<R>;
    private readonly _radius;
    private constructor();
    get radius(): R;
    resolve(resolver: Circle.Resolver): Circle.Canonical;
    equals(value: Circle): boolean;
    equals(value: unknown): value is this;
    hash(hash: Hash): void;
    toJSON(): Circle.JSON;
    toString(): string;
}
/**
 * @internal
 */
export declare namespace Circle {
    type Canonical = Circle<Length.Canonical>;
    interface JSON extends Value.JSON<"circle"> {
        radius: Length.JSON;
    }
    type Resolver = Length.Resolver;
    const parse: CSSParser<Circle>;
}
//# sourceMappingURL=circle.d.ts.map