import { Parser } from "@siteimprove/alfa-parser";
import type { Slice } from "@siteimprove/alfa-slice";
import type { Token } from "../../../../syntax/index.js";
import { Circle } from "./circle.js";
import { Ellipse } from "./ellipse.js";
import { Extent } from "./extent.js";
/**
 * @internal
 */
export type Shape = Circle | Ellipse | Extent;
/**
 * Radial gradient shapes
 *
 * @remarks
 * The syntax inside a radial-gradient() function is significantly different
 * from the basic shape functions circle() and ellipse(), so we cannot easily
 * reuse the code.
 *
 * @internal
 */
export declare namespace Shape {
    type JSON = Circle.JSON | Ellipse.JSON | Extent.JSON;
    type Canonical = Circle.Canonical | Ellipse.Canonical | Extent.Canonical;
    type Resolver = Circle.Resolver & Ellipse.Resolver & Extent.Resolver;
    type PartiallyResolved = Circle.Canonical | Ellipse.PartiallyResolved | Extent.Canonical;
    type PartialResolver = Circle.Resolver & Ellipse.PartialResolver & Extent.Resolver;
    function partiallyResolve(resolver: PartialResolver): (value: Shape) => PartiallyResolved;
    const parse: Parser<Slice<Token>, Shape, string, []>;
}
//# sourceMappingURL=shape.d.ts.map